<?php

/**
 * This software is intended for use with Oxwall Free Community Software http://www.oxwall.org/ and is
 * licensed under The BSD license.

 * ---
 * Copyright (c) 2011, Oxwall Foundation
 * All rights reserved.

 * Redistribution and use in source and binary forms, with or without modification, are permitted provided that the
 * following conditions are met:
 *
 *  - Redistributions of source code must retain the above copyright notice, this list of conditions and
 *  the following disclaimer.
 *
 *  - Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
 *  the following disclaimer in the documentation and/or other materials provided with the distribution.
 *
 *  - Neither the name of the Oxwall Foundation nor the names of its contributors may be used to endorse or promote products
 *  derived from this software without specific prior written permission.

 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
 * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
$plugin = OW::getPluginManager()->getPlugin('videogroup');

$classesToAutoload = array(
    'VideogroupProviders' => $plugin->getRootDir() . 'classes' . DS . 'videogroup_providers.php'
);

OW::getAutoloader()->addClassArray($classesToAutoload);

OW::getRouter()->addRoute(
    new OW_Route(
        'videogroup_viewgroup_list',
        'videogroup/viewlist/:listType/',
        'VIDEOGROUP_CTRL_Videogroup',
        'viewList',
        array('listType' => array('default' => 'latest'))
    )
);

OW::getRouter()->addRoute(new OW_Route('videogroup_list_index', 'videogroup/', 'VIDEOGROUP_CTRL_Videogroup', 'viewList'));

OW::getRouter()->addRoute(new OW_Route('viewgroup_clip', 'videogroup/view/:id/', 'VIDEOGROUP_CTRL_Videogroup', 'view'));
OW::getRouter()->addRoute(new OW_Route('editgroup_clip', 'videogroup/edit/:id/', 'VIDEOGROUP_CTRL_Videogroup', 'edit'));
OW::getRouter()->addRoute(new OW_Route('viewgroup_list', 'videogroup/viewlist/:listType/', 'VIDEOGROUP_CTRL_Videogroup', 'viewList'));
OW::getRouter()->addRoute(new OW_Route('viewgroup_list_group', 'videogroup/viewlist/:listType/group/:groupId', 'VIDEOGROUP_CTRL_Videogroup', 'viewList'));
OW::getRouter()->addRoute(new OW_Route('viewgroup_tagged_list_st', 'videogroup/viewlist/tagged/', 'VIDEOGROUP_CTRL_Videogroup', 'viewTaggedList'));
OW::getRouter()->addRoute(new OW_Route('viewgroup_tagged_list', 'videogroup/viewlist/tagged/:tag', 'VIDEOGROUP_CTRL_Videogroup', 'viewTaggedList'));
OW::getRouter()->addRoute(new OW_Route('videogroup_user_videogroup_list', 'videogroup/user-videogroup/:user', 'VIDEOGROUP_CTRL_Videogroup', 'viewUserVideogroupList'));
OW::getRouter()->addRoute(new OW_Route('videogroup_upload', 'videogroup/add/:group', 'VIDEOGROUP_CTRL_Add', 'index'));

OW::getRouter()->addRoute(new OW_Route('videogroup_admin_config', 'admin/videogroup/', 'VIDEOGROUP_CTRL_Admin', 'index'));

OW::getThemeManager()->addDecorator('videogroup_list_item', $plugin->getKey());

/*function videogroup_elst_add_new_content_item( BASE_CLASS_EventCollector $event )
{
    if ( !OW::getUser()->isAuthorized('videogroup', 'add') )
    {
        return;
    }

    $resultArray = array(
        BASE_CMP_AddNewContent::DATA_KEY_ICON_CLASS => 'ow_ic_videogroup',
        BASE_CMP_AddNewContent::DATA_KEY_URL => OW::getRouter()->urlFor('VIDEOGROUP_CTRL_Add', 'index'),
        BASE_CMP_AddNewContent::DATA_KEY_LABEL => OW::getLanguage()->text('videogroup', 'videogroup')
    );

    $event->add($resultArray);
}

OW::getEventManager()->bind(BASE_CMP_AddNewContent::EVENT_NAME, 'videogroup_elst_add_new_content_item');


function videogroup_quick_links( BASE_CLASS_EventCollector $event )
{
    $service = VIDEOGROUP_BOL_ClipService::getInstance();
    $userId = OW::getUser()->getId();
    $username = OW::getUser()->getUserObject()->getUsername();

    $clipCount = (int) $service->findUserClipsCount($userId);

    if ( $clipCount > 0 )
    {
        $event->add(array(
            BASE_CMP_QuickLinksWidget::DATA_KEY_LABEL => OW::getLanguage()->text('videogroup', 'my_videogroup'),
            BASE_CMP_QuickLinksWidget::DATA_KEY_URL => OW::getRouter()->urlForRoute('videogroup_user_videogroup_list', array('user' => $username)),
            BASE_CMP_QuickLinksWidget::DATA_KEY_COUNT => $clipCount,
            BASE_CMP_QuickLinksWidget::DATA_KEY_COUNT_URL => OW::getRouter()->urlForRoute('videogroup_user_videogroup_list', array('user' => $username))
        ));
    }
}
OW::getEventManager()->bind(BASE_CMP_QuickLinksWidget::EVENT_NAME, 'videogroup_quick_links');

*/

function videogroup_delete_user_content( OW_Event $event )
{
    $params = $event->getParams();

    if ( !isset($params['deleteContent']) || !(bool) $params['deleteContent'] )
    {
        return;
    }

    $userId = (int) $params['userId'];

    if ( $userId > 0 )
    {
        VIDEOGROUP_BOL_ClipService::getInstance()->deleteUserClips($userId);
    }
}
OW::getEventManager()->bind(OW_EventManager::ON_USER_UNREGISTER, 'videogroup_delete_user_content');


function videogroup_on_notify_actions( BASE_CLASS_EventCollector $e )
{
    $e->add(array(
        'section' => 'videogroup',
        'action' => 'videogroup-add_comment',
        'description' => OW::getLanguage()->text('videogroup', 'email_notifications_setting_comment'),
        'sectionIcon' => 'ow_ic_videogroup',
        'sectionLabel' => OW::getLanguage()->text('videogroup', 'email_notifications_section_label'),
        'selected' => true
    ));
}
OW::getEventManager()->bind('notifications.collect_actions', 'videogroup_on_notify_actions');

function videogroup_add_comment_notification( OW_Event $event )
{
    $params = $event->getParams();

    if ( empty($params['entityType']) || $params['entityType'] !== 'videogroup_comments' )
    {
        return;
    }

    $entityId = $params['entityId'];
    $userId = $params['userId'];
    $commentId = $params['commentId'];

    $clipService = VIDEOGROUP_BOL_ClipService::getInstance();
    $userService = BOL_UserService::getInstance();

    $clip = $clipService->findClipById($entityId);

    if ( $clip->userId != $userId )
    {
        $params = array(
            'pluginKey' => 'videogroup',
            'entityType' => 'videogroup_add_comment',
            'entityId' => $commentId,
            'action' => 'videogroup-add_comment',
            'userId' => $clip->userId,
            'time' => time()
        );
        
        $comment = BOL_CommentService::getInstance()->findComment($commentId);
        $url = OW::getRouter()->urlForRoute('viewgroup_clip', array('id' => $entityId));
        $avatars = BOL_AvatarService::getInstance()->getDataForUserAvatars(array($userId));
        
        $data = array(
            'avatar' => $avatars[$userId],
            'string' => array(
                'key' => 'videogroup+email_notifications_comment',
                'vars' => array(
                    'userName' => $userService->getDisplayName($userId),
                    'userUrl' => $userService->getUserUrl($userId),
                    'videogroupUrl' => $url,
                    'videogroupTitle' => strip_tags($clip->title)
                )
            ),
            'content' => $comment->getMessage(),
            'url' => $url
        );

        $event = new OW_Event('notifications.add', $params, $data);
        OW::getEventManager()->trigger($event);
    }
}
OW::getEventManager()->bind('base_add_comment', 'videogroup_add_comment_notification');

function videogroup_feed_entity_add( OW_Event $e )
{
    $params = $e->getParams();
    $data = $e->getData();

    if ( $params['entityType'] != 'videogroup_comments' )
    {
        return;
    }

    $videogroupService = VIDEOGROUP_BOL_ClipService::getInstance();
    $clip = $videogroupService->findClipById($params['entityId']);
    $thumb = $videogroupService->getClipThumbUrl($clip->id);

    $url = OW::getRouter()->urlForRoute('viewgroup_clip', array('id' => $clip->id));

    $content = UTIL_String::truncate(strip_tags($clip->description), 150, '...');
    $title = UTIL_String::truncate(strip_tags($clip->title), 100, '...');

    if ( $thumb == "undefined" )
    {
        $thumb = $videogroupService->getClipDefaultThumbUrl();

        $markup  = '<div class="clearfix"><div class="ow_newsfeed_item_picture">';
        $markup .= '<a style="display: block;" href="' . $url . '"><div style="width: 75px; height: 60px; background: url('.$thumb.') no-repeat center center;"></div></a>';
        $markup .= '</div><div class="ow_newsfeed_item_content"><a href="' . $url . '">' . $title . '</a><div class="ow_remark">';
        $markup .= $content . '</div></div></div>';
    }
    else
    {
        $markup  = '<div class="clearfix ow_newsfeed_large_image"><div class="ow_newsfeed_item_picture">';
        $markup .= '<a href="' . $url . '"><img src="' . $thumb . '" /></a>';
        $markup .= '</div><div class="ow_newsfeed_item_content"><a href="' . $url . '">' . $title . '</a><div class="ow_remark">';
        $markup .= $content . '</div></div></div>';
    }
	$group = GROUPS_BOL_Service::getInstance()->findGroupById($clip->groupId);
	$groupUrl = OW::getRouter()->urlForRoute('groups-view', array(
						'groupId' => $group->id,
			));
	$groupName = UTIL_String::truncate(strip_tags($group->title), 25, '...');
	$lang = OW::getLanguage();
	$string = $lang->text('videogroup', 'feed_adding_descriptions', 
					array('groupUrl' => $groupUrl, 'groupName' => $groupName)
				); 
	
    $data = array(
        'time' => (int) $clip->addDatetime,
        'ownerId' => $clip->userId,
        'content' => '<div class="clearfix">' . $markup . '</div>',
		'string' => $string,
        'view' => array(
            'iconClass' => 'ow_ic_videogroup'
        )
    );

    $e->setData($data);
}

OW::getEventManager()->bind('feed.on_entity_add', 'videogroup_feed_entity_add');


function videogroup_ads_enabled( BASE_CLASS_EventCollector $event )
{
    $event->add('videogroup');
}

OW::getEventManager()->bind('ads.enabled_plugins', 'videogroup_ads_enabled');


$credits = new VIDEOGROUP_CLASS_Credits();
OW::getEventManager()->bind('usercredits.on_action_collect', array($credits, 'bindCreditActionsCollect'));


function videogroup_add_auth_labels( BASE_CLASS_EventCollector $event )
{
    $language = OW::getLanguage();
    $event->add(
        array(
            'videogroup' => array(
                'label' => $language->text('videogroup', 'auth_group_label'),
                'actions' => array(
                    'add' => $language->text('videogroup', 'auth_action_label_add'),
                    'view' => $language->text('videogroup', 'auth_action_label_view'),
                    'add_comment' => $language->text('videogroup', 'auth_action_label_add_comment'),
                    'delete_comment_by_content_owner' => $language->text('videogroup', 'auth_action_label_delete_comment_by_content_owner')
                )
            )
        )
    );
}

OW::getEventManager()->bind('admin.add_auth_labels', 'videogroup_add_auth_labels');


function videogroup_privacy_add_action( BASE_CLASS_EventCollector $event )
{
    $language = OW::getLanguage();

    $action = array(
        'key' => 'videogroup_view_videogroup',
        'pluginKey' => 'videogroup',
        'label' => $language->text('videogroup', 'privacy_action_view_videogroup'),
        'description' => '',
        'defaultValue' => 'everybody'
    );

    $event->add($action);
}

OW::getEventManager()->bind('plugin.privacy.get_action_list', 'videogroup_privacy_add_action');


function videogroup_on_change_privacy( OW_Event $e )
{
    $params = $e->getParams();
    $userId = (int) $params['userId'];

    $actionList = $params['actionList'];

    if ( empty($actionList['videogroup_view_videogroup']) )
    {
        return;
    }

    VIDEOGROUP_BOL_ClipService::getInstance()->updateUserClipsPrivacy($userId, $actionList['videogroup_view_videogroup']);
}

OW::getEventManager()->bind('plugin.privacy.on_change_action_privacy', 'videogroup_on_change_privacy');

function videogroup_feed_collect_configurable_activity( BASE_CLASS_EventCollector $event )
{
    $language = OW::getLanguage();
    $event->add(array(
        'label' => $language->text('videogroup', 'feed_content_label'),
        'activity' => '*:videogroup_comments'
    ));
}

OW::getEventManager()->bind('feed.collect_configurable_activity', 'videogroup_feed_collect_configurable_activity');

function videogroup_feed_collect_privacy( BASE_CLASS_EventCollector $event )
{
    $event->add(array('create:videogroup_comments', 'videogroup_view_videogroup'));
}

OW::getEventManager()->bind('feed.collect_privacy', 'videogroup_feed_collect_privacy');

function videogroup_feed_videogroup_comment( OW_Event $event )
{
    $params = $event->getParams();

    if ( $params['entityType'] != 'videogroup_comments' )
    {
        return;
    }

    $service = VIDEOGROUP_BOL_ClipService::getInstance();
    $userId = $service->findClipOwner($params['entityId']);

    if ( $userId == $params['userId'] )
    {
        $string = OW::getLanguage()->text('videogroup', 'feed_activity_owner_videogroup_string');
    }
    else
    {
        $userName = BOL_UserService::getInstance()->getDisplayName($userId);
        $userUrl = BOL_UserService::getInstance()->getUserUrl($userId);
        $userEmbed = '<a href="' . $userUrl . '">' . $userName . '</a>';
        $string = OW::getLanguage()->text('videogroup', 'feed_activity_videogroup_string', array('user' => $userEmbed));
    }

    OW::getEventManager()->trigger(new OW_Event('feed.activity', array(
        'activityType' => 'comment',
        'activityId' => $params['commentId'],
        'entityId' => $params['entityId'],
        'entityType' => $params['entityType'],
        'userId' => $params['userId'],
        'pluginKey' => 'videogroup'
    ), array(
        'string' => $string
    )));
}
OW::getEventManager()->bind('feed.after_comment_add', 'videogroup_feed_videogroup_comment');

function videogroup_feed_videogroup_like( OW_Event $event )
{
    $params = $event->getParams();

    if ( $params['entityType'] != 'videogroup_comments' )
    {
        return;
    }

    $service = VIDEOGROUP_BOL_ClipService::getInstance();
    $userId = $service->findClipOwner($params['entityId']);

    $userName = BOL_UserService::getInstance()->getDisplayName($userId);
    $userUrl = BOL_UserService::getInstance()->getUserUrl($userId);
    $userEmbed = '<a href="' . $userUrl . '">' . $userName . '</a>';

    $lang = OW::getLanguage();
    if ( $params['userId'] == $userId )
    {
        $string = $lang->text('videogroup', 'feed_activity_owner_videogroup_like');
    }
    else
    {
        $string = $lang->text('videogroup', 'feed_activity_videogroup_string_like', array('user' => $userEmbed));
    }

    OW::getEventManager()->trigger(new OW_Event('feed.activity', array(
        'activityType' => 'like',
        'activityId' => $params['userId'],
        'entityId' => $params['entityId'],
        'entityType' => $params['entityType'],
        'userId' => $params['userId'],
        'pluginKey' => 'videogroup'
    ), array(
        'string' => $string
    )));
}
OW::getEventManager()->bind('feed.after_like_added', 'videogroup_feed_videogroup_like');

function feedOnItemRender( OW_Event $event ) {
        $params = $event->getParams();

        $entityType = $params['action']['entityType'];
        $clipId = $params['action']['entityId'];
        $autoId = $params['autoId'];
	if ( $entityType != 'videogroup_comments' )
    {
        return;
    }
    
    /*********** check who can view feed ********/
        //TODO
		$videogroupService = VIDEOGROUP_BOL_ClipService::getInstance();
    	$clip = $videogroupService->findClipById($clipId);
    	
    	/*********** check who can view group ********/
    	$groupDto = GROUPS_BOL_Service::getInstance()->findGroupById($clip->groupId);
    	if ( !GROUPS_BOL_Service::getInstance()->isCurrentUserCanView($groupDto->userId) )
        {
           OW::getDocument()->addOnloadScript('$("#'. $autoId .'").html("")');
        }
        
        $invite = GROUPS_BOL_Service::getInstance()->findInvite($groupDto->id, OW::getUser()->getId());
        
    	if ( $groupDto->whoCanView == GROUPS_BOL_Service::WCV_INVITE && !OW::getUser()->isAuthorized('groups') )
        {
            if ( !OW::getUser()->isAuthenticated() )
            {
               OW::getDocument()->addOnloadScript('$("#'. $autoId .'").html("")');
            }

            $user = GROUPS_BOL_Service::getInstance()->findUser($groupDto->id, OW::getUser()->getId());

            if ( $groupDto->whoCanView == GROUPS_BOL_Service::WCV_INVITE && $invite === null && $user === null )
            {
               OW::getDocument()->addOnloadScript('$("#'. $autoId .'").html("")');
            }
        }
        
    	/*********** check who can view group ********/
}
OW::getEventManager()->bind('feed.on_item_render', 'feedOnItemRender');